///////////////////////////////////////////////////////////
// Interfacet^SH2{[h                            //
// newlibpŉʃ[`Cu                      //
// for newlib-1.14.0                                     //
// Wriiten by Shinichi Yamagiwa                          //
///////////////////////////////////////////////////////////

// newlib-1.14.0/newlib/libc/sys/sh/syscalls.cɖ[̓o͕@gbvg`Œ`Ă܂B
// ł͂̊֐ۂ̃{[hœ삷悤ɒ`Ȃ܂B

#include <reent.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/times.h>
#include <_syslist.h>

#include <stdio.h>

#include <errno.h>

#include <cq_sh7144.h>

#undef errno
int errno;

static int __board_fgetc(unsigned char *strbuf, int reqcount);
static int __board_fputc(unsigned char *strbuf, int reqcount);
static long __get_timer_in_usec();
static long __get_timer_in_sec();

// isatty
// syscalls.oɒ`Ă邪
#undef isatty
int isatty ( int desc ){

  return 1;
}

// _open_r
// ̊֐́AopenĂ΂ꂽƂɎs܂B
// Wo͂͏AftHgŊmۂĂ̂
// Kɏ̔wԍłԂĂ܂B
// ۂ̂ƂA܂T|[g܂B
int
_open_r (ptr, file, flags, mode)
     struct _reent *ptr;
     _CONST char *file;
     int flags;
     int mode;
{
  return 55;
}

// _sbrk_r
//̊֐́Amallocŗ̈mۂۂɌĂяo܂B
// q[vincroCg̗̈mۂāÅmۂꂽ̈
// 擪|C^Ԃ܂B
// mۂ̈悪傫Ƃ-1Ԃ܂B
// malloc̓T|[gȂ̂-1܂B
void *
_sbrk_r (ptr, incr)
     struct _reent *ptr;
     ptrdiff_t incr;
{
  return (caddr_t) -1;
}

// _fstat_r
// stat()Ă΂ꂽƂɈȉ̊֐Ă΂܂B
// t@CɊւĂ͕Wo݂͂̂Ă̂ŁA
// LN^foCXł邱ƂZbgA
// ǂݏ̒Pʂ4096byteɐݒ肵Ă܂i̒l͓Kɂ߂ĂjB
// 0^[܂B
int
_fstat_r (ptr, fd, pstat)
     struct _reent *ptr;
     int fd;
     struct stat *pstat;
{
  pstat->st_mode = S_IFCHR;
  pstat->st_blksize = 4096;
  return 0;
}

// _lseek_r
// AWo͂V[NȂ̂ŁiꂽƂĂӖȂ)A
// posԂ悤ɂĂ܂B
off_t
_lseek_r (ptr, fd, pos, whence)
     struct _reent *ptr;
     int fd;
     off_t pos;
     int whence;
{
  return pos;
}

// _read_r
// readĂ΂ꂽۂɎsŉʂ̓ǂݏo[`B
// W݂͂̂T|[gB
// ł̃C^tF[Xł́A1ǂݏos
// iǂݏoȂƂnum0ŕԂ邪BBBjA
// ^C}[ȂǂgĒPʎԂ̕ԂȂǂ
// |[OԂłB
// Ӂj͕@̕ύX__board_fgetc()ĂB
_ssize_t
_read_r (ptr, fd, buf, cnt)
     struct _reent *ptr;
     int fd;
     _PTR buf;
     size_t cnt;
{
  int num;

  num = __board_fgetc(buf,cnt);
  return num;
}

// _write_r
// writeĂ΂ꂽۂɎsŉʂ̏o[`B
// Wo݂͂̂T|[gB
// ł̃C^tF[Xł́A镪oĕԂ܂B
// ^C}[ȂǂgĒPʎԂ̕ԂȂǂ
// |[OԂłB
// Ӂjo͕@̕ύX__board_fputc()ĂB
_ssize_t
_write_r (ptr, fd, buf, cnt)
     struct _reent *ptr;
     int fd;
     _CONST _PTR buf;
     size_t cnt;
{
  unsigned char *buf_tmp;
  _ssize_t written_cnt;

  buf_tmp = (unsigned char *)buf;
  written_cnt = __board_fputc(buf_tmp, cnt);

  return written_cnt;
}

// _close_r
// close֐Ă΂ꂽƂɁÅ֐t@CfBXNv^܂B
// Wo͕͂Ȃ̂ŁA܂B
int
_close_r (ptr, fd)
     struct _reent *ptr;
     int fd;
{
  return 0;
}

// _fcntl_r
// Wo͈ȊOAT|[gȂAĂ΂ꂽ炢B
int
_fcntl_r (ptr, fd, cmd, arg)
     struct _reent *ptr;
     int fd;
     int cmd;
     int arg;
{
  return 0;
}

//_execve_r
// OSȂƂOɂĂ̂ŁAexec̓G[ɕԂB
int
_execve_r (ptr, name, argv, env)
     struct _reent *ptr;
     char *name;
     char **argv;
     char **env;
{
  errno = EIO;
  return -1;
}

// _fork_r
// VO^XN݂̂̂ŁAɃG[ԂB
int
_fork_r (ptr)
     struct _reent *ptr;
{
  errno = ENOMEM;
  return -1;
}

// _link_r
// t@CVXeȂ̂ŁAG[ɕԂB
int
_link_r (ptr, old, new)
     struct _reent *ptr;
     _CONST char *old;
     _CONST char *new;
{
  errno = EIO;
  return -1;
}

// _kill_r
// vZX͑ȂƂOƂĂ܂̂ŁA
// ɐB
int
_kill_r (ptr, pid, sig)
     struct _reent *ptr;
     int pid;
     int sig;
{
  errno = 0;
  return 0;
}

// _getpid_r
// 1ȏ̃vZX͑Ȃ̂ŁA0ԂB
int
_getpid_r (ptr)
     struct _reent *ptr;
{
  return 0;
}

// _times_r
// times֐Ă΂ꂽƂɍŉʂ̊֐ƂČĂ΂܂B
// VXeñ^CȂ񂩂Ԃ΂̂ł͂ȂƎv܂B
// ł͉ɂĂ܂񂪁B
clock_t
_times_r (ptr, ptms)
     struct _reent *ptr;
     struct tms *ptms;
{
  return 0;
}

// _gettimeofday_r
// gettimeofday֐Ă΂ꂽƂɍŉẘ֐Ƃē삵܂B
// __get_timer_in_usec()__get_timer_in_sec()ĂB
int
_gettimeofday_r (ptr, ptimeval, ptimezone)
     struct _reent *ptr;
     struct timeval *ptimeval;
     struct timezone *ptimezone;
{
  ptimeval->tv_usec = __get_timer_in_usec();
  ptimeval->tv_sec = __get_timer_in_sec();
  return 0;
}

// _unlink_r
// t@CVXeȂ̂ŁAG[ɕԂB
int
_unlink_r (ptr, file)
     struct _reent *ptr;
     _CONST char *file;
{
  errno = EIO;
  return -1;
}

//####################################
// {[h̊֐S
//###################################

extern struct _cq_sh7144_status ___cq_sh7144_status;

// W͂̕@Freqcount͂@ĂB
// ̊֐͖{̓mubNŎĂBł̓ubN܂B
// ǂݏo\ԂłȂƂ0ԂĂB
// unsigned char *strbuf --------- ǂݏoi[obt@
// int reqcount ---------- vꂽǂݏo
static int __board_fgetc(unsigned char *strbuf, int reqcount){
  unsigned char c;
  int i;
  
  for(i=0;i<reqcount;i++){
    strbuf[i] = cq_sh7144_getchar(___cq_sh7144_status.stdout_port_num);
  }  
  return reqcount;
}

// Wo͂̕@Freqcounto͂@ĂB
// ̃C^tF[X͖{̓mubNŏĂBł̓ubN܂B
// ubNoȂǂƍɂȂƎv܂B
// unsigned char *strbuf --------- ǂݏoi[obt@
// int reqcount ---------- vꂽǂݏo
static int __board_fputc(unsigned char *strbuf, int reqcount){
  int i;

  for(i=0;i<reqcount;i++){
    cq_sh7144_putchar(___cq_sh7144_status.stdin_port_num, strbuf[i]);
  }
  return reqcount;
}

// gettimeofdayŗp}CNZJh̎擾
// PɌ݂̎usecPʂŕԂ܂B
static long __get_timer_in_usec(){/*  */
}

// gettimeofdayŗpZJh̎擾
// PɌ݂̎secPʂŕԂ܂B
static long __get_timer_in_sec(){
}


