///////////////////////////////////////////////////////////
// Interfacet^SH2{[h                            //
// newlibpŉʃ[`Cu                      //
// for newlib-1.14.0                                     //
// Wriiten by Shinichi Yamagiwa                          //
///////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include<malloc.h> // mallinfo

#include <cq_sh7144.h>

// VA|[g̐ݒێϐ
struct _cq_sh7144_status ___cq_sh7144_status;


// VA|[g𐶂֐łB荞݂ŋ쓮Ȃ悤ɐݒ肵
// B荞݋쓮邽߂ɂ͕ʓrA荞݃Cl[urbgZb
// gR[hĂBbaudrateɂ9600,19200w\łB
// ȊÕ{[[gw肷ƓۏႵ܂B
// SCI_noɂ0,1wł܂BȊOw肷ƁAۏႵ܂B
// ̑̐ݒ́F
// 8bit
// peBȂ
// Stoprbg1rbg
void cq_sh7144_activate_SCI(int SCI_no, int baudrate){
  volatile unsigned short *PACRL2;
  volatile unsigned char *SMR0,*BRR0,*SCR0,*TDR0,*SSR0,*RDR0,*SDCR0;
  volatile unsigned char *SMR1,*BRR1,*SCR1,*TDR1,*SSR1,*RDR1,*SDCR1;
  volatile unsigned short *MSTCR1;
  int i;

  MSTCR1 = (unsigned short *)0xFFFF861C;
  
  PACRL2 = (unsigned short *)0xFFFF838E;
  SMR0 = (unsigned char *)0xFFFF81A0;
  BRR0 = SMR0+1;
  SCR0 = SMR0+2;
  TDR0 = SMR0+3;
  SSR0 = SMR0+4;
  RDR0 = SMR0+5;
  SDCR0 = SMR0+6;

  SMR1 = (unsigned char *)0xFFFF81B0;
  BRR1 = SMR1+1;
  SCR1 = SMR1+2;
  TDR1 = SMR1+3;
  SSR1 = SMR1+4;
  RDR1 = SMR1+5;
  SDCR1 = SMR1+6;

  switch(SCI_no){
  case 1:
    // SCI1X^oCԂ
    *MSTCR1 &= ~0x2;
    // TXD1,RXD1Cl[u 
    *PACRL2 = ((1<<8) | (1<<6));
    // 8bit
    // peBȂ
    // Stoprbg1rbg
    *SCR1 = 0x0;
    *SMR1 = 0x0;
    if(baudrate == 9600)
      // 9600bps (CKS = 00, BRR=77)
      *BRR1 = 77;
    else if(baudrate == 19200)
      // 19200bps (CKS = 00, BRR=38)
      *BRR1 = 38;
    // 1rbg҂ԁiKɒ҂j
    for(i=0;i<(*BRR1*1000);i++){}
    // MAM
    *SCR1 = ((1<<5)|(1<<4));
    break;
  case 0:
    // SCI0X^oCԂ
    *MSTCR1 &= ~0x1;
    // TXD0,RXD0Cl[u 
    *PACRL2 |= ((1<<2) | (1<<0));
    // 8bit
    // peBȂ
    // Stoprbg1rbg
    *SCR0 = 0x0;
    *SMR0 = 0x0;
    if(baudrate == 9600)
      // 9600bps (CKS = 00, BRR=77)
      *BRR0 = 77;
    else if(baudrate == 19200)
      // 19200bps (CKS = 00, BRR=38)
      *BRR0 = 38;
    // 1rbg҂ԁiKɒ҂j
    for(i=0;i<(*BRR0*1000);i++){}
    // MAM
    *SCR0 = ((1<<5)|(1<<4));
    break;
  }
}

// VA|[g1oCgM֐łBSCI_noɃVA|[g
// ԍAcɑMoCgnĂB
// M܂ŃubN܂B
void cq_sh7144_putchar(int SCI_no, unsigned char c){
  volatile unsigned char *TDR0,*SSR0;
  volatile unsigned char *TDR1,*SSR1;

  switch(SCI_no){
  case 0:
    TDR0 = (unsigned char *)0xFFFF81A3;
    SSR0 = TDR0+1;

    // Mobt@̋󂫂҂
    while((*SSR0 & (1<<7)) == 0){}
    // Mf[^
    *TDR0 = c;
    // MJn
    *SSR0 = *SSR0 & ~(1<<7);
    break;
  case 1:
    TDR1 = (unsigned char *)0xFFFF81B3;
    SSR1 = TDR1+1;
    
    // Mobt@̋󂫂҂
    while((*SSR1 & (1<<7)) == 0){}
    // Mf[^
    *TDR1 = c;
    // MJn
    *SSR1 = *SSR1 & ~(1<<7);
    break;
  }  
}

// VA|[g1oCgM֐łBSCI_noɃVA|[g
// ԍAMoCgԂ܂B
// M܂ŃubN܂B
unsigned char cq_sh7144_getchar(int SCI_no){
  volatile unsigned char *RDR0,*SSR0;
  volatile unsigned char *RDR1,*SSR1;
  char recv_char;

  switch(SCI_no){
  case 0:
    SSR0 = (unsigned char *)0xFFFF81A4;
    RDR0 = SSR0+1;
    
    while((*SSR0 & (1<<6)) == 0){
      if((*SSR0 & (1<<5)) != 0)
	*SSR0 &= ~(1<<5);
    }
    recv_char = *RDR0;
    *SSR0 &= ~(1<<6);
    break;    
  case 1:
    SSR1 = (unsigned char *)0xFFFF81B4;
    RDR1 = SSR1+1;
    
    while((*SSR1 & (1<<6)) == 0){
      if((*SSR1 & (1<<5)) != 0)
	*SSR1 &= ~(1<<5);
    }
    recv_char = *RDR1;
    *SSR1 &= ~(1<<6);
    break;
  }
  
  return recv_char;
}

// {[hŗL̕Wo̓t@Cpӂ
FILE _cq_stdout;
FILE _cq_stdin;
// Ggg\̂|C^extern
struct _reent _cq_reent;
extern struct _reent *_impure_ptr;

extern int __swrite(
		    _PTR cookie,
		    char _CONST *buf,
		    int n);

extern int __sread(
		   _PTR cookie,
		   char *buf,
		   int n);

// Wo͂ŗpobt@
unsigned char _cq_iobuf_out[16];
unsigned char _cq_iobuf_in[1];

// IO̐ݒ֐łBvO̍ŏłłB
// stdoutstdiñ|[gꍇA{[[g͓łȂ΂܂B
void cq_sh7144_init_io
(
 int stdout_port_num, // stdoutŗpVA|[g̔ԍw肷
 int stdout_baudrate, // stdout̃VA|[g̃{[[g
 int stdin_port_num, // stdinŗpVA|[g̔ԍw肷
 int stdin_baudrate // stdout̃VA|[g̃{[[g
 )
{

  // stdio.hŒ`ĂstdinAstdout̒`pĐVɒ`Ȃ
#undef stdout
#undef stdin
  FILE *stdout;
  FILE *stdin;

  // Wo͂ŗpVA|[gݒ肷
  if(stdout_port_num == stdin_port_num){
    cq_sh7144_activate_SCI(stdout_port_num, stdout_baudrate);
    cq_sh7144_activate_SCI(stdin_port_num, stdin_baudrate);
  }
  else{
    cq_sh7144_activate_SCI(stdout_port_num, stdout_baudrate);
  }

  ___cq_sh7144_status.stdout_port_num = stdout_port_num;
  ___cq_sh7144_status.stdin_port_num = stdin_port_num;
  
  // {[hŗL̓o̓t@Cw悤ɂ
  stdout = &_cq_stdout;
  stdin = &_cq_stdin;

  // Wo͂̐ݒ
  _cq_stdout._p = _cq_iobuf_out;
  _cq_stdout._r = 0;
  _cq_stdout._w = 16;
  _cq_stdout._flags = __SWR | __SSTR | __SLBF;
  _cq_stdout._file = -1;
  _cq_stdout._bf._base = _cq_iobuf_out;
  _cq_stdout._bf._size = 16;
  _cq_stdout._lbfsize = 0;
  _cq_stdout._cookie = &_cq_stdout;
  _cq_stdout._write = &__swrite;

  // W͂̐ݒ
  _cq_stdin._p = _cq_iobuf_in;
  _cq_stdin._r = 0;
  _cq_stdin._w = 0;
  _cq_stdin._flags = __SRD;
  _cq_stdin._file = -1;
  _cq_stdin._bf._base = _cq_iobuf_in;
  _cq_stdin._bf._size = 1;
  _cq_stdin._ub._base = NULL;
  _cq_stdin._ub._size = 0;
  _cq_stdin._lbfsize = 0;
  _cq_stdin._cookie = &_cq_stdin;
  _cq_stdin._read = &__sread;

  //  _global_impure_ptr = &_cq_reent;
  // _impure_ptrƂ̂_REENT
  _cq_reent.__sdidinit = 1; // ς݂ɂ
  _cq_reent._stdout = &_cq_stdout;
  _cq_reent._stdin = &_cq_stdin;
  _impure_ptr = &_cq_reent;
  
}



