	.text

	.extern		_main
	.extern		_monitor
	.extern		_sdata_va
	.extern		_save_registers
#==============================================================================
#      SH-2 Exception Vector
#==============================================================================
	.long	_startup
	.long	0xFFFFFFFC		
	.org	0x200
	#ERI_0
	.long	0x00000000
	#RXI_0
	.long	_RXI_0_exception
	#TXI_0
	.long	0x00000000
	#TEI_0
	.long	0x00000000
	#ERI_1
	.long	0x00000000
	#RXI_1
	.long	_RXI_1_exception
	#TXI_1
	.long	0x00000000
	#TEI_1
	.long	0x00000000
	.align 4
_startup:
	#dataZNVRs[
	mov.l	_ram_base_addr, r1
	mov.l	_data_section_start_addr,r2
	mov.l	_data_section_end_addr, r3
_data_copy_loop:	
	mov.b	@r2, r4
	mov.b	r4,@r1
	add	#1,r1
	add	#1,r2
	cmp/hs	r2,r3	
	bt	_data_copy_loop

	#荞ݗDx14ɉ
	stc	sr,r1
	mov	#0xF0, r2
	not	r2,r2
	and	r2,r1
	add	#0xE0,r1
	ldc	r1,sr
	
	
	mov.l	_start_addr_list,r1
	jmp	@r1
	nop

	.align 4
_RXI_0_exception:
	#PC,SRȊÕWX^X^bNɑޔ
	sts.l	macl,@-r15
	sts.l	mach,@-r15
	stc.l	vbr,@-r15
	stc.l	gbr,@-r15
	sts.l	pr,@-r15
	mov.l	r14,@-r15
	mov.l	r13,@-r15
	mov.l	r12,@-r15
	mov.l	r11,@-r15
	mov.l	r10,@-r15
	mov.l	r9,@-r15
	mov.l	r8,@-r15
	mov.l	r7,@-r15
	mov.l	r6,@-r15
	mov.l	r5,@-r15
	mov.l	r4,@-r15
	mov.l	r3,@-r15
	mov.l	r2,@-r15
	mov.l	r1,@-r15
	mov.l	r0,@-r15

	mov.l	_save_registers_addr, r1
	jsr	@r1
	nop
	mov.l	_monitor_addr, r1	
	jsr	@r1
	nop
	
	#PC,SRȊÕWX^X^bN畜A
	mov.l	@r15+,r0
	mov.l	@r15+,r1
	mov.l	@r15+,r2
	mov.l	@r15+,r3
	mov.l	@r15+,r4
	mov.l	@r15+,r5
	mov.l	@r15+,r6
	mov.l	@r15+,r7
	mov.l	@r15+,r8
	mov.l	@r15+,r9
	mov.l	@r15+,r10
	mov.l	@r15+,r11
	mov.l	@r15+,r12
	mov.l	@r15+,r13
	mov.l	@r15+,r14
	lds.l	@r15+,pr
	ldc.l	@r15+,gbr
	ldc.l	@r15+,vbr
	lds.l	@r15+,mach
	lds.l	@r15+,macl
	# O烊^[
	RTE
	nop
_RXI_1_exception:
	#PC,SRȊÕWX^X^bNɑޔ
	sts.l	macl,@-r15
	sts.l	mach,@-r15
	stc.l	vbr,@-r15
	stc.l	gbr,@-r15
	sts.l	pr,@-r15
	mov.l	r14,@-r15
	mov.l	r13,@-r15
	mov.l	r12,@-r15
	mov.l	r11,@-r15
	mov.l	r10,@-r15
	mov.l	r9,@-r15
	mov.l	r8,@-r15
	mov.l	r7,@-r15
	mov.l	r6,@-r15
	mov.l	r5,@-r15
	mov.l	r4,@-r15
	mov.l	r3,@-r15
	mov.l	r2,@-r15
	mov.l	r1,@-r15
	mov.l	r0,@-r15

	mov.l	_save_registers_addr, r1
	jsr	@r1
	nop
	mov.l	_monitor_addr, r1	
	jsr	@r1
	nop
	
	#PC,SRȊÕWX^X^bN畜A
	mov.l	@r15+,r0
	mov.l	@r15+,r1
	mov.l	@r15+,r2
	mov.l	@r15+,r3
	mov.l	@r15+,r4
	mov.l	@r15+,r5
	mov.l	@r15+,r6
	mov.l	@r15+,r7
	mov.l	@r15+,r8
	mov.l	@r15+,r9
	mov.l	@r15+,r10
	mov.l	@r15+,r11
	mov.l	@r15+,r12
	mov.l	@r15+,r13
	mov.l	@r15+,r14
	lds.l	@r15+,pr
	ldc.l	@r15+,gbr
	ldc.l	@r15+,vbr
	lds.l	@r15+,mach
	lds.l	@r15+,macl
	# O烊^[
	RTE
	nop
	
	.align 4
_start_addr_list:
	.long	_main
_monitor_addr:
	.long	_monitor
_data_section_start_addr:
	.long	_sdata
_data_section_end_addr:
	.long	_edata
_ram_base_addr:
	.long	_sdata_va
_save_registers_addr:
	.long	_save_registers
