///////////////////////////////////////////////////////
// CQ$B=PHG<R(BInterface SH2$B4pHD8~$1%W%m%0%i%`(B           //
// practice2 : LED$BE@LG!u%7%j%"%k%]!<%H$G%k!<%W%P%C%/(B //
// Copyright (C) Shinichi Yamagiwa, 2006             //
///////////////////////////////////////////////////////

// $B%7%j%"%k%]!<%H$NM-L5$K$7$?$,$C$F0J2<$N9T$r@8$+$7$F$/$@$5$$!#(B
// $BN>J}$N%7%j%"%k%]!<%H$r;H$o$J$$>l9g!"(BLED$B$,E@LG$7$^$9!#(B
//#define USE_SCI0
#define USE_SCI1

// GCC$B$,(Bmemcopy$B$rMW5a$9$k$N$G0J2<$rDj5A$9$k(B
// C$B8@8lI8=`$N%$%s%?%U%'!<%9$H$9$k(B
void *memcpy(void *OUT, const void *IN, int N){

  int i;

  for(i=0;i<N;i++){
    ((unsigned char *)OUT)[i] = ((unsigned char *)IN)[i];
  }

  return OUT;

}

// SCI0$B$N<u?.Nc30=hM}(B
void SCI0_RXI_func(){
  volatile unsigned short *PACRL2;
  volatile unsigned char *SMR0,*BRR0,*SCR0,*TDR0,*SSR0,*RDR0,*SDCR0;
  char recv_char;

  SMR0 = (unsigned char *)0xFFFF81A0;
  BRR0 = SMR0+1;
  SCR0 = SMR0+2;
  TDR0 = SMR0+3;
  SSR0 = SMR0+4;
  RDR0 = SMR0+5;
  SDCR0 = SMR0+6;

  recv_char = *RDR0;
  *SSR0 &= ~(1<<6);

  // $B<u?.$7$?%G!<%?$r%k!<%W%P%C%/$9$k(B
  while((*SSR0 & (1<<7)) == 0){
    // $B%*!<%P%i%s%(%i!<$,H/@8$7$?$i%j%;%C%H(B
    if((*SSR0 & (1<<5)) != 0)
      *SSR0 &= ~(1<<5);
  }
  *TDR0 = recv_char;
  *SSR0 = *SSR0 & ~(1<<7);
}

// SCI1$B$N<u?.Nc30=hM}(B
void SCI1_RXI_func(){
  volatile unsigned char *SMR0,*BRR0,*SCR0,*TDR0,*SSR0,*RDR0,*SDCR0;
  volatile unsigned char *SMR1,*BRR1,*SCR1,*TDR1,*SSR1,*RDR1,*SDCR1;
  char recv_char;

  SMR1 = (unsigned char *)0xFFFF81B0;
  BRR1 = SMR1+1;
  SCR1 = SMR1+2;
  TDR1 = SMR1+3;
  SSR1 = SMR1+4;
  RDR1 = SMR1+5;
  SDCR1 = SMR1+6;

  recv_char = *RDR1;
  *SSR1 &= ~(1<<6);
  
  // $B<u?.$7$?%G!<%?$r%k!<%W%P%C%/$9$k(B
  while((*SSR1 & (1<<7)) == 0){
    // $B%*!<%P%i%s%(%i!<$,H/@8$7$?$i%j%;%C%H(B
    if((*SSR1 & (1<<5)) != 0)
      *SSR1 &= ~(1<<5);
  }
  *TDR1 = recv_char;
  *SSR1 = *SSR1 & ~(1<<7);
}

int main(){
  volatile unsigned short *io_port_E;
  volatile unsigned short *PECRL1, *PEIORL;
  volatile int i;
  volatile unsigned short *PACRL2;
  volatile unsigned short *IPRF;
  volatile unsigned char *SMR0,*BRR0,*SCR0,*TDR0,*SSR0,*RDR0,*SDCR0;
  volatile unsigned char *SMR1,*BRR1,*SCR1,*TDR1,*SSR1,*RDR1,*SDCR1;
  char message0[] = "This is SH2 CQ board. Serial Port0 exception test started.\r\n";
  char message1[] = "This is SH2 CQ board. Serial Port1 exception test started.\r\n";
  volatile unsigned short *MSTCR1;
  char recv_char;

  IPRF = (unsigned short *)0xFFFF8352;

  MSTCR1 = (unsigned short *)0xFFFF861C;

  PACRL2 = (unsigned short *)0xFFFF838E;
  SMR0 = (unsigned char *)0xFFFF81A0;
  BRR0 = SMR0+1;
  SCR0 = SMR0+2;
  TDR0 = SMR0+3;
  SSR0 = SMR0+4;
  RDR0 = SMR0+5;
  SDCR0 = SMR0+6;

  SMR1 = (unsigned char *)0xFFFF81B0;
  BRR1 = SMR1+1;
  SCR1 = SMR1+2;
  TDR1 = SMR1+3;
  SSR1 = SMR1+4;
  RDR1 = SMR1+5;
  SDCR1 = SMR1+6;

#ifdef USE_SCI1
  // SCI1$B$r%9%?%s%P%$>uBV$+$i2r=|(B
  *MSTCR1 &= ~0x2;
  // TXD1,RXD1$B$r%$%M!<%V%k(B 
  *PACRL2 = ((1<<8) | (1<<6));
  // 9600bps (CKS = 00, BRR=77)
  // $BD4JbF14|(B
  // 8bit
  // $B%Q%j%F%#$J$7(B
  // Stop$B%S%C%H(B1$B%S%C%H(B
  *SCR1 = 0x0;
  *SMR1 = 0x0;
  *BRR1 = 77;
  for(i=0;i<(*BRR1*1000);i++){}
  // $B<u?.3d$j9~$_5v2D!"Aw?.5v2D!"<u?.5v2D(B
  *SCR1 = ((1<<6)|(1<<5)|(1<<4));
  *IPRF |= 0xF;

  i=0;
  while(message1[i] != '\0'){
    // $BAw?.%P%C%U%!$N6u$-$rBT$D(B
     while((*SSR1 & (1<<7)) == 0){}
    // $BAw?.%G!<%?=q$-9~$_(B
    *TDR1 = message1[i];
    // $BAw?.3+;O(B
    *SSR1 = *SSR1 & ~(1<<7);
    i++;
  }
#endif
  
#ifdef USE_SCI0
  // SCI0$B$r%9%?%s%P%$>uBV$+$i2r=|(B
  *MSTCR1 &= ~0x1;
  // TXD0,RXD0$B$r%$%M!<%V%k(B 
  *PACRL2 |= ((1<<2) | (1<<0));
  
  // 9600bps (CKS = 00, BRR=77)
  // $BD4JbF14|(B
  // 8bit
  // $B%Q%j%F%#$J$7(B
  // Stop$B%S%C%H(B1$B%S%C%H(B
  *SCR0 = 0x0;
  *SMR0 = 0x0;
  *BRR0 = 77;
  for(i=0;i<(*BRR0*1000);i++){}
  // $B<u?.3d$j9~$_5v2D!"Aw?.5v2D!"<u?.5v2D(B
  *SCR0 = ((1<<6)|(1<<5)|(1<<4));
  *IPRF |= (0xF<<4);

  i=0;
  while(message0[i] != '\0'){
    // $BAw?.%P%C%U%!$N6u$-$rBT$D(B
     while((*SSR0 & (1<<7)) == 0){}
    // $BAw?.%G!<%?=q$-9~$_(B
    *TDR0 = message0[i];
    // $BAw?.3+;O(B
    *SSR0 = *SSR0 & ~(1<<7);
    i++;
  }
#endif

  // LED$B$NE@LG(B
  PECRL1 = (unsigned short *)0xFFFF83B8;
  PEIORL = (unsigned short *)0xFFFF83B4;
  io_port_E = (unsigned short *)0xFFFF83B0;

  *PECRL1 &= 0x0FFF;
  *PEIORL |= (1<<15);
  *io_port_E = (1<<15);

  while(1){
    for(i=0;i<1000000;i++);
    
    *io_port_E = *io_port_E & 0x7FFF;

    for(i=0;i<1000000;i++);

    *io_port_E = *io_port_E | (1<<15);
  }

  return 0;

}

